#!/bin/sh
PATH=/bin:/usr/bin:/usr/local/bin
export PATH

# queueing system for x10cmd
QDIR=/var/spool/x10

if [ "$#" != 0 ]
then
	F=/
	while [ -e "$F" ]
	do
		F=`date +%s.%N`
	done
	# put into queue
	echo "$@" > $QDIR/$F
fi

# get lock (or not)
LCK=$QDIR/lock
TLCK=$LCK.$$
echo "$$" > $TLCK
if [ ! -s $TLCK ]
then
	echo Could not make link lock $TLCK >&2
	exit
else
	trap "rm -f $TLCK; exit 1" 1 2 3 15

	COUNT=0
	until link $TLCK $LCK
	do
		PID=`cat $LCK`
		if [ -n "$PID" ]
		then
			KILL=`/bin/kill -0 $PID 2>&1`
			case "$KILL" in
			*such\ process*)
				rm -f $LCK
				;;
			esac
		fi
		COUNT=`expr $COUNT + 1`
		if [ $COUNT = 15 ]
		then
			echo Could not link lock $LCK >&2
			rm $TLCK
			exit
		fi
		sleep 1
	done
	rm $TLCK
fi

# run queue
(
	for F in $QDIR/[0-9]*
	do
		if [ -r "$F" ]
		then
			x10cmd `cat $F`
			rm -f $F
		fi
	done
	rm -f $LCK
) # &
